# std::domain_error

From cppreference.com
< cpp‎ | error

Defined in header `<stdexcept>` |  |
class domain_error; |  |

Defines a type of object to be thrown as exception. It may be used by the implementation to report domain errors, that is, situations where the inputs are outside of the domain on which an operation is defined.

The standard library components do not throw this exception (mathematical functions report domain errors as specified in math_errhandling). Third-party libraries, however, use this. For example, boost.math throws `std::domain_error` if `boost::math::policies::throw_on_error` is enabled (the default setting).

Inheritance diagram

### Member functions

(constructor) | constructs the exception object (public member function)

## std::domain_error::domain_error

explicit domain_error( const std::string& what_arg ); | (1) |
explicit domain_error( const char* what_arg ); | (2) | (since C++11)

Constructs the exception object with `what_arg` as explanatory string that can be accessed through what().

Because copying `std::exception` is not permitted to throw exceptions, this message is typically stored internally as a separately-allocated reference-counted string. This is also why there is no constructor taking `std::string&&`: it would have to copy the content anyway.

### Parameters

what_arg | - | explanatory string

### Exceptions

May throw std::bad_alloc

## Inherited from std::exception

### Member functions

(destructor) [virtual] | destructs the exception object (virtual public member function of `std::exception`)
what [virtual] | returns an explanatory string (virtual public member function of `std::exception`)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/error/domain_error&oldid=70816"